# PS&G GDD

# Quick Overview

TPS/Character action game hybrid game

# Aesthetic

Basically it is gothic horror. Very dark but the locations should always be visible and readable. Lots of moody fog in outdoor areas. 

# Character

Gunslinger/Vampire Hunter D lookin' ~~dude~~ GIRL

She has a hat and a probably a trench coat. Really just a classic gunslinger look. 

# Gameplay

## Locomotion (walking, running, etc.)

Normal walking speed should be pretty fast (~475 cm/s or whatever units the UE4 char movement component uses). Should have very high acceleration and deceleration so the movement is snappy. ~~Should only be fast enough so that the "stopping" animation on the character looks correct. No visible/perceivable sliding!~~

<aside>
💡 Don't tweak walk speed to accommodate starting/stopping animations. Just tweak it until it feels good and implement some kind of motion matching to make the start/stop look correct.

</aside>

If you walk in the same relative direction for ~2 seconds you will initiate a sprint. 

<aside>
💡 I also want to try having it be something like holding the dodge button and after the dodge if you are still pressing a movement direction you will sprint instead of walk.

</aside>

By same relative direction I mean that you do not make any sudden direction changes (say input direction is within +/-90 deg of the current movement direction. Sprint has a speed of ~600 but the rotation rate is greatly reduced. Best example is how the roadie run feels in Gears of War.

## Mobility (dodges, jumping, etc.)

### Dodge

You can dodge in 4 cardinal directions. Left, right, forward, and back. Dodge is relative to where camera is facing. You can slightly change your direction by rotating the camera. The rotation rate is not much just enough to sort of circle around your opponent so you can follow up with a melee attack or line up a shot when you recover from the dodge. The dodge has a brief invincibility period at the beginning (lets say 6-8 frames?). It starts fast and is quick. You can do 3 dodges back to back. If you perform a 4th dodge the character will do a big flip/roll. Has the same invincibility and goes farther but has a much greater recovery. This should discourage dodge spam without having the need for a stupid ass "cooldown" meter.

### Air Dodge

You can dodge in the air. You are also limited to 2 dodges in the air. 

<aside>
💡 Want to experiment with limiting how you can do subsequent dodges in the air. Would it be fine to let the player do 2 consecutive air dodges in the same direction? I know some fighting games limit this but in a full 3D game in a big arena do I really need to limit that type of mobility? Leaning on no...

</aside>

There is no big flip/roll in the air; a 3rd dodge input will just do nothing. You can restore your dodges by doing a reload in the air. Air dashing cancels all current air acceleration and momentum including forces caused by firing weapons like the shotgun. You could use this to cancel all the backwards momentum that happens when you fire the shotgun in the air. The tradeoff is you need to commit to the dash and use up one of your limited 2 dodges.

### Jumping

Jump has a few frames of startup. Probably something in between a Street fighter jump and a DMC jump in terms of how quickly you come off the ground. Your arc will be determined by what direction you were holding when you pressed the button. You have some air control but not much. You should only be able to control yourself in the air when you are falling.

You get one additional jump in the air. Like the air dodge, jumping in the air cancels all current air acceleration and momentum including forces caused by firing weapons like the shotgun. This includes momentum cause by the initial jump. This means you can change the trajectory you were heading based on your first jump from the ground as a means of faking out your opponent and otherwise making yourself harder to hit.

### Wall jumping

When in the air and hugging and facing a wall you can press the jump button to perform a wall jump. When this happens the player character will perform a kicking animation and then kick off the wall. Like a regular grounded jump, the kick will take a short amount of time to play out the animation before the actual forces are applied and the jump is performed. You will kick off the wall backwards from where the camera is facing. You will always be launched upward and away from the wall. If you measured the trajectory from the wall it should make a 30 degree angle. There would be some time after the wall jump before you could perform any additional actions such as an air jump or air dodges. Wall jumping restores all of your air actions (2 dodges and an air jump). A player could wall jump, cancel the wall jump with an air dodge back into the wall, and do another wall jump. They could chain these together to traverse vertically through the level.   

## Gunplay

Guns are good! You can shoot them.

Press the left mouse button to shoot (duh). When you are firing your weapon your walk speed is slowed down a bit. Walk speed increases as your recovery animation is finishing. 

Right now I'm thinking ammo will be unlimited? Each gun will still have an amount that can be loaded and fired before having to be reloaded since reloading is a big part of the game system.

Shooting a gun in the air will give you a bit of a launching effect. Basically you'd be able to keep yourself afloat by firing the weapon. Different guns MIGHT have a different effect. For example the revolver might give you a tiny force upward and maybe also slightly backwards but not much. The shotgun on the other hand might launch you backwards from the firing direction. 

Firing happens from the camera but will need to be a bit more sophisticated than "shoot a ray from the camera center into the world and see what it hits." For other gameplay reasons I want to have the camera somewhat far out. We should make sure that checks are done to make sure we don't count hits on enemies or objects that are behind the player. Projectile weapons should also be adjusted so they don't end up shooting behind the player or anything when we determine where their endpoint is.

### Special Gun Moves

**Active reload** - Basically a Gears of War style active reload. After pressing the reload button a meter will appear where a cursor travels across a bar. This represents the time it takes to reload the weapon. There will be a section on the bar  somewhere in the middle or beginning. Pressing the reload button again when the cursor is on this section will reload the gun early and play a stylish reload animation as opposed to a slow animation. For example for the revolver the character will start by unlocking the barrel(?) of the revolver and pouring out all the spent shells. Then will proceed to load all 6 bullets. However, if you perform a successful active reload, the character will throw up all 6 bullets and spin her body and catch the bullets with the revolver barrel(?) in mid-air. 

**~~Perfect active reload (Unlockable)** - Say you have a 30 frame window of time to perform a regular active reload. In the middle of that 30 frame window would be a 3 frame window where if you press the reload button you will perform a "perfect" reload. This perfect reload has all the benefits of a normal active reload such as faster reload recovery but will also charge your gun's charge shot instantaneously.~~  

**Tricky reload (Unlockable?)** - Instead of pressing the reload button again to perform an active reload, you can input a melee attack, dodge, jump, or use your gadget. If you perform the active reload successfully using on of these inputs, you will cancel the reload animation and perform that move. You can also perform a perfect active reload using this technique.

**~~Perfect tricky reload??? (Unlockable)** - Maybe instead of getting a charge shot after performing a perfect active reload using an input other than the reload button, you perform a powered up version of the move you just did. Say you do a launcher with your sword and get extra height or something. Not sure about this one.~~        

**Reload cancel (Unlockable)** - Allows you to cancel attack/ability that is normally uninterruptable. Does not apply to other uninterruptable states like getting hit or grabbed. Can only be done if the character's equipped weapon has been fired once already (current ammo loaded ≠ max ammo that can be loaded). Depending on the move you canceled, you might keep some of the inertia from said move. For example if you cancel the grapple hook you might keep the momentum from when you were being pulled by the grapple hook.

**~~Charge shot** - Holding the fire button will charge your gun. You will see a glint move across your gun. When the shot is fully charged your gun will glow with some kind of energy effect. You can let go at this point and perform a powerful shot. The properties of the charge shot will depend on the gun. The charge shot will have a bit of recover as opposed to the normal shot.~~

**Disarm** - shooting enemy's hand/weapon when attack animation is between wind up and active frames (for example take a side axe swing. Enemy would bring axe sort of behind their back, then swing from one side to the other. The attack would connect while the axe is completely in front of their body or in the middle of their swing whichever way you want to think about it. Once the attack is initiated but before it is active would be the timing where you can shoot their hand/weapon and disarm them. They would lose their weapon and also be put in a long stagger state)

### Guns

**Revolver** - starting weapon, revolver type, 6 shots, can cause enemy stagger by hitting weak points (head, shoulders, arms, knees), adds slight upward force to enemy when they are shot in air (just enough to keep them stopped in the air for a second)

- Charge shot causes explosion on impact and launches enemy high on direct hit. Splash damage around explosion will knock enemies back.

**Double barrel shotgun** - 2nd weapon shotgun type, 2 shots, powerful, blows enemies away when they are grounded and in air (and maybe ground too), launched away from the origin of the shot (probably player camera??). In air player will be launched backwards from shot direction. Charge shot will cause enemies to either be splatted against the wall or bounce off the ground. Depends on what they collide with after being shot and flung backwards.

**~~Crossbow/bolt gun** - 3rd weapon sniper type (fast projectile), 1 shot (long reload) but the highest damage (when fully charged at least). When fully charged, has the unique property of impaling small enemies, which takes them with the bolt as it flies through the air and will pin enemies against walls if the projectile collides with a wall. Aiming with this weapon looks down a scope as opposed to looking over the shoulder~~

**~~Firework launcher** - rocket launcher type (projectile). pretty normal rocket launcher weapon that can be charge up to 6 times. Each charge releases an additional firework that will fire when you let go of the fire button. Honestly this is probably the least thought out weapon of the bunch the spike dynamite might make this redundant.~~ 

## Melee

### Weapons

**Sword** - a saber type sword. Your most basic weapon with no real gimmicks. Has a 3-4 hit combo on the ground (see asset tracker for how attacks should animate). Has a 3 hit combo in the air. Last hit of the air combo spikes. 

- [https://youtu.be/armk6g6XQxw?t=173](https://youtu.be/armk6g6XQxw?t=173)
- ~~Can hold the attack button to charge up a special move. Once charge starts weapon will show a glint very similar to how the gun works. When the move is charged (indicated by some sort of energy around the weapon) you can let go of the button to perform a rapid slashes.~~
- Pressing back and the melee button performs a launcher.
- Double tap Forward + melee performs a stinger type move. You will be launched forward and will travel until you are near an enemy (or the move ends naturally) and perform a thrusting stab which will cause the enemy to slide along the ground.

**~~Blade yo-yo thing** - main gimmick with this weapon is you can hold the melee button after doing an attack to keep the yoyo out and spinning. This will continue to hit enemies and do damage. When the yoyo is being held out you can switch to another weapon. The rope you were holding on to will break but the blade will continue to stay where it is and keep spinning and doing damage. Eventually it will lose angular momentum and will fall to the ground. You will need to pick it up to use the weapon again (you can pick it up by just running over to it or by using the grapple hook to bring it to you).~~

- [https://castlevania.fandom.com/wiki/Disc_Armor](https://castlevania.fandom.com/wiki/Disc_Armor)
- [https://youtu.be/tfuUUeF1Rg4?t=75](https://youtu.be/tfuUUeF1Rg4?t=75)

**~~Rocket boom hammer thing** - I explain how the hammer would work in Game One GDD. Check that out. There should be some gimmick with it being able to fling you around.~~

- ~~Back + Atk - Upward "golf swing" attack~~

S~~omething like Nero's tomboy moveset is what I'd be going for:~~

[https://youtu.be/xFG_pHlHxiI](https://youtu.be/xFG_pHlHxiI)

## Gadgets

The game will have an slot where you can equip gadgets. Gadgets cannot be changed mid-battle and can only be swapped at designated checkpoints/shops/etc. The gadget can be used via the Q button. Some gadgets will have moves that can be done by holding the button or delaying the button press if the gadget has some form of "combo."

Certain gadgets will have meter management associated with them. In general I want to avoid any kind of cooldown system. I think using "meter" instead of cooldowns is better because it makes moves that would be overpowered fair without completely taking away control from when the player can and can't use them. The players can expedite getting access to these powerful moves again by playing well.  Building meter can be affected by the style system to give another incentive to play well.

### The gadgets

**Grapple Hook** - press the grapple button to fire your grappling hook. ~~You don't need to be aiming directly at the enemy.~~ ~~There will be a UI element showing what enemy the grapple will go toward if you were to press the grapple button.~~ For this to work in multiplayer you absolutely need to aim it.

**Spike dynamite** - can be rolled (aiming down) or thrown (aiming up). When fully charged you can release the fire button and the player will punch forward with the grenade in their hand. If they hit an enemy the spikes will expand and stick the the enemy. The player will then kick off enemy into the air. Dynamite can be shot at any time to explode it prematurely. Enemies are launched up and away from explosion.

**~~Coin flip** - Can flip a coin in the air. Shooting the coin makes the bullet ricochet of the coin and automatically hit enemies within range. Takes a single coin from your currency~~ THIS IS JUST A RIP OFF OF THAT MOVE YOU CAN DO IN ULTRAKILL

**~~Stopwatch -** use to go into a bullet time type mode. Press gadget button to activate. Has a meter which depletes while the stopwatch is active. If the meter is full and the stopwatch is activated during moments which naturally slow down (perfect dodges and parrying enemies with the gun) will cause time to stop temporarily.~~

## Other stuff

- There will be some gravity scaling at the apex of your launch trajectory
    - Basically we want the player to have an opportunity to perform follow up attacks easier
- There will be various universal stagger states like getting splatted against a wall and bouncing off the ground
    - This will depend of the properties of the move

# Multiplayer Addendum

## Launchers, Hitstun and Recovery

In certain circumstances, the victim of an attack will be unable to move or act for a period of time depending on both the attack performed and also some conditions when the attack connected. The following are some rules around how hitstun and recovery work in MULTIPLAYER. 

### Recovering from getting knocked down to the ground

- Some attacks will cause the victim to end up in a state where they are lying on the ground, after some period they will begin to get up
    - The victim can do nothing, in which case they will get up in place
    - The victim can hold on of the 4 cardinal directions + the dodge button
        - When the victim is getting up, they will instead perform a roll in the direction being held
    - These both will have some invincibility at the beginning on the animation

### Recovering in the air

- Some attacks will cause the victim to end up in a state where they are stunned in the air and susceptible to being juggled
    - The victim can press the just the dodge button, in which case they will do a small flip in place (while carrying a little bit of their air momentum)
    - The victim can hold on of the 4 cardinal directions + the dodge button
        - The victim will do a flip in the direction being held
    - These both will have some invincibility at the beginning on the animation

### Getting hit by attacks on the ground

- Getting hit by melee attacks will cause some hitstun for the victim
    - The hitstun duration is such that follow up attacks in the main sword melee combo will connect
    - If the instigator instead cancels into one of the launcher moves the victim will have time between when they recover from hitstun and the launcher connects to perform a dodge or jump
- Getting hit by the revolver on the ground doesn't cause any hitstun but WILL still cause damage
    - The only exception to this is if the shooter hits the victims weapon as they are attacking causing a weapon disarm. The weapon disarm is technically hitstun but is basically another state entirely which might have different properties than normal hitstun. It will almost certainly have a different animation and duration than normal hitstun.
- Getting hit by the shotgun at a long range won't cause hitstun but WILL cause damage
    - Getting hit by the shotgun at super close range will cause the victim to get blown back
    
    <aside>
    💡 I'm on the fence about this feature
    
    </aside>
    

### Getting hit by attacks in the air

- Melee attacks in the air cause some hitstun
    - They will also cause the victim to be launched again ever so slightly
    
    <aside>
    💡 They either get relaunched or their vertical movement is stopped and gravity is temporarily 0 for a short period
    
    </aside>
    
- Shots from the revolver and shotgun work as they do on the ground UNLESS the victim has been launched
    - If the victim has been launched then shots will work as they are described previously in this GDD

### Hitstun of launchers

- Regular launcher's hitstun is such that the victim can recover in the air right after the apex of them being launched when they are starting to fall back down to the ground
- Charge launcher has much more hitstun basically they can tech right before they hit the ground or wait until the hit the ground to tech
- Note that the launched victim MUST use one of their air recovery actions
    - If they don't use an air recovery they will remain in hitstun and fall to the ground

## Health

- There are two types of "health" the player can have
    1. Actual health...should be pretty self explanatory
    2. "Red health" even if the color this is represented as doesn't end up as being red...
        1. Red health will show up on the player's health bar trailing their actual remaining health
        2. The player's actual health is just what is represented in white/green (again not sure on the colors but this is hopefully a good enough explanation that it is clear...) the red health is what they CAN recover by one of two means described later below 
- When the victim of an attack (melee or projectile/bullet) takes damage there are one of two ways the victim can lose health
    1. The player is hit with a melee attack
        1. Any current red health the victim has is depleted
        2. The victim takes straight damage to their actual health
    2. The player is hit with a bullet
        1. The player takes damage and is split between actual straight damage done to the victim's actual health and red/recoverable health
            1. Depending on the gun being used the amount of recoverable/actual damage will change. For example the revolver might do 90-95% of its damage as recoverable damage and only 5-10% of its damage as actual damage. A sniper rifle on the other hand might do 50% actual damage and 50% recoverable damage.
        2. This health can be recovered in two ways
            1. Not taking damage for a period of time → the red health will slowly recover
            2. Hitting an enemy player with your melee attack → recovers chunks of red damage as each hit connects (basically the Bloodborne rally system)
                1. Maybe some percentage of the actual damage done by the attack being performed?

## Main game mode

- Main game mode is either 1v1, 2v2, 3v3, or 4v4
    - It is elimination style meaning once you are killed you need to wait until the next round
    - A match is first to 5-10 wins
- The gadgets mentioned previously can be selected at the start as the player's "loadout"
    - Can pick one and you must keep it for the entire match
- There are "power weapons" on the map you can pick up
    - These will eventually consist of both strong guns and melee weapons
        - For now only the sniper rifle will be able to be picked up
    - Guns that are power weapons will have limited ammunition, **unlike the revolver and the shotgun**
        - You will need to run over the gun on the map once it respawns to get more ammo for it
    - Power weapons are on a respawn timer
    - To pick up the power weapon you will actually have to stand over it and hold the button for a period before you pick it up
        - There is an animation of the player character picking up the weapon before they can do anything else